(function(){
var additionalData = [
["Pages/Page_159221837.html","Overview",
"Overview\nOverview\nThis guide provides a general overview of Unity for Wii U, conventions used in the guides, and links to other resources for information on Unity.\n Note\n Building for the Nintendo Wii U system requires the Wii U add-on and a serial key provided by Nintendo for the Professional Edition of Unity.\nIntroduction to Unity for Wii U\nUnity is an integrated development environment for game creation used by over 2.5 million game developers all over the world. It supports multiple platforms and makes it possible to do real-time development while your game is running. It provides a fast and easy-to-use development environment equipped with the various technologies necessary for game development, such as fast and powerful 3D graphic functionality, animation, AI, scripts, and SFX, enabling expressive and fast game development. Of course, the various Wii U features are supported, such as the Wii U GamePad and Wii Remote controllers, and it provides strong support for developing games that make great use of these Wii U features.\nTopics in This Section\n \t Conventions\n \t Additional Resources\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221840.html","Conventions",
"Conventions\nConventions\n This section describes the conventions used throughout the guides in the Tutorials section on Nintendo Developer Portal.\n Tutorial Structure\n The Tutorials section for each platform contains a number of guides, each about a specific topic. The topic is further broken down into individual sections. A section can contain a general description of a concept, step-by-step instructions on how to implement the concept, or both. The guides can be read in any order, but some assume the reader is already familiar with the materials in the earlier guides.\n Individual sections are generally structured as follows.\n \tAn introduction that describes what the section covers.\n \tAny requirements before you can start.\n \tAn explanation of any important platform-specific concepts.\n \tA step-by-step guide of how to implement the concepts in code.\n The bottom of each page includes links to the previous and next section in the current guide. Use the left-hand navigation tree to go to a different guide.\n Code Samples\n Many of the sections include code samples that demonstrate how to implement certain Unity features on specific Nintendo platforms. Depending on the complexity of the concept being explained, code may be provided as a snippet or as a complete code file. All code samples are provided in C# only.\n Formatting\n The guides use the following conventions for formatting text.\n \tThe names of specific UI elements are given in bold text.\n \tThe names of classes, variables, methods, and Unity components are given in monospace text.\n \tMenu sequences are separated by a greater-than symbol (>). For example,\nSelect Edit > Project Settings > Player to view PlayerSettings in the Inspector tab.\n Warning\n A Warning block provides critical information. Always read the information in a warning block before completing the step in which it appears.\n Note\n A Note block provides important information such as guideline requirements and platform-specific information that is important to know in most situations.\n Info\n An Info block provides supplementary information that is not necessarily required, but might be useful in certain situations. This includes guideline recommendations.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221842.html","Additional Resources",
"Additional Resources\nAdditional Resources\nFor support and more information about Unity for Wii U and Unity in general, refer to the following resources.\nUnity Documentation\nInformation specific to Unity for Wii U can be found in the Unity Manual. The Manual can be accessed from the Editor via Help > Unity Manual WiiUPlayer (or for Unity 5.2 and earlier versions, see Help > Unity Manual) or it can be found in your Unity install folder under Editor/Data/PlaybackEngines/WiiUPlayer/Documentation/en/Manual/index.html. There are a number of helpful sections under Platform Specific > Wii U including Getting Started, Audio, Input, Saving, and a list of unsupported features. We highly recommend that you read through all of the Wii U specific sections before you begin developing new titles or porting existing ones.\nUnity Home Page\nIf you have any general questions about Unity and its features, the Unity home page includes a wealth of information, assets, and tutorials. It also has support forums, questions and answers, and an issue tracker.\nUnity for Wii U Support Forum\nIf you have any questions about Unity for Wii U that are not covered in the Unity documentation or this guide, post a question in the support forums.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221846.html","What Devkit Should I Buy?",
"What Devkit Should I Buy?\nWhat Devkit Should I Buy?\nThere are two devkits for the Wii U: the CAT-DEV and CAT-R. The CAT-DEV is the full-featured devkit useful for debugging and optimization. The CAT-R is closer to the retail Wii U. It is less expensive, has fewer features, and is generally used for testing. Although it is possible to develop only on a CAT-R, loading your game takes longer and you lose debugging/optimization features. For those reasons, we recommend developing with a CAT-DEV. See below for a comparison of the two kits.\nComparison of Features\nLoading your game\n \t Feature \tCAT-DEV \tCAT-R\n \tLoad directly from your PC (takes a few seconds after a successful build) \t✓ \t\n \t Load via SD card (takes additional steps and a few minutes after a successful build) \t✓ \t✓\n Debugging/Optimization\n \tFeature \tCAT-DEV \tCAT-R\n \t Real time Wii U log output to PC\n *(For CAT-R, this requires additional cables and additional steps)\n \t✓ \t✓*\n \tGPU debugging (Spark) captures (Useful for optimization and finding bottlenecks) \t✓ \t\n \tUnity script debugging \t✓ \t✓\n \tUnity Profiler \t✓ \t✓\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221850.html","Development Environment",
"Development Environment\nSetting Up the Development Environment\nThis guide explains how to set up the Unity development environment on your PC. Before you begin, make sure you already have a Nintendo Developer ID and your PC meets the Host PC Requirements.\nTopics in This Section\n \t Operating Requirements\n \t 1. Installing Nintendo Dev Interface\n \t 2. Installing Required Software Packages\n \t 3. Setting up Unity\n \t 4. Verifying Your Environment\n \t 5. Setting up Your Devkit\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221855.html","Operating Requirements",
"Operating Requirements\nOperating Requirements\nHardware Requirements\n \tCAT-DEV or CAT-R Development Kit\n \tWii U GamePad (also called 'DRC')\n \tA TV or Monitor (with either HDMI, Component, S-Video or Composite input)\n \t(optional) A Wireless Access Point OR a Wii Wired LAN Adapter (for connecting to the internet)\nHost PC Requirements\n \tMicrosoft Windows 7 Professional (64-bit)\n \tAdministrator privileges\n \tA 2 GHz Core 2 Duo processor or better\n \tAt least 1 GB of RAM\n \tAt least 40 GB Hard Disk space, NTFS-formatted\n \t Microsoft .NET Framework 2.0 SP2 or compatible (3.5 SP1 which comes pre-installed with Windows 7 is sufficient)\n Note\n Windows 10 is not currently supported.\nRequired Software Packages\n \t CAFE-SDK\n Info\n The required SDK version can be found on the Middleware Version Table on the Nintendo Developer Portal or in the Unity for Wii U download description on the Downloads page.\n \t GHS Multi (Compiler, Linker, Debugger Software)\n Info\n The required version can be found in the Unity for Wii U download description. You can find this on the Downloads page on Nintendo Developer Portal.\n \tGHS Multi Common License\n \tHostBridge Software\n \t Unity for Wii U\n Info\n The Unity for Wii U license can be found in the Unity for Wii U download description. You can find this on the Downloads page on Nintendo Developer Portal.\n Note\n If you are doing a manual installation (not using the Nintendo Dev Interface) keep these in mind:\n \tFor Unity 5.2 and earlier versions, the download package contains two EXE files: an editor and a support patch. You must install both.\n \tFor Unity 5.3 and later versions, Unity for Wii U uses the public version of the editor, however be sure your Unity version matches the Unity for Wii U patch version exactly.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221879.html","1. Installing Nintendo Dev Interface",
"1. Installing Nintendo Dev Interface\n1. Installing Nintendo Dev Interface\nBegin by downloading and installing Nintendo Dev Interface (NDI), a package manager for the software used when developing for Nintendo platforms.\n \tSign in to Nintendo Developer Portal (https://developer.nintendo.com).\n \tClick Developer Support in the second navigation bar from the top of the page.\n \tClick your target development platform on the left menu, and then click Downloads.\n \tUnder the Nintendo Dev Interface Download section at the top of the page, click Download and save the package to your hard drive.\n \tExtract the package and run ndi_setup.exe.\n \tFollow the instructions in the setup wizard to install NDI.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159221898.html","Setting up CAT-DEV",
"Setting up CAT-DEV\nSetting up the CAT-DEV Development Kit\nThis document will guide you through physically setting up your CAT-DEV Development Kit and configuring the software for the development hardware. If you have not already installed the SDK, Host Bridge Software and the MULTI Tool Chain, you must do so first. Refer to Installing Nintendo Dev Interface and Installing Required Software Packages.\nRequired hardware for setting up the CAT-DEV\n \tCAT-DEV Development Kit\n \tDRC-DK (Wii U Development GamePad)\n \tDRC-DK Coaxial Cable (Connector cable for the Gamepad)\n \tWii U AC Adapter\n \tWii U GamePad AC Adapter\n \tWii Classic Controller Pro\n \tHDMI Cable or Wii Composite AV Cable\n \tCategory 5e LAN Cable\n \tA TV or Monitor with HDMI, Component, S-Video or Composite input. Wii U supports resolutions between 480i and 1080p\n \tAn SD Card at least 1 GB or larger in size\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228157.html","1. Connecting the CAT-DEV",
"1. Connecting the CAT-DEV\n1. Connecting your CAT-DEV to the PC\nThere are three ways to connect your devkit to your PC: an unmanged switch, a second network card, or connecting to it directly. Using an unmanaged switch is the recommended method. Refer to the following chart for the advantages and disadvantages for each before deciding.\n \tConnection Method \tAdvantages \tDisadvantages\n \tUnmanaged Switch \t \tIsolates the connection between the PC and the CAT-DEV from most network policies (such as disabled DHCP, forbidden broadcast traffic, or restricted unicast traffic).\n \tIsolates the connection from most other traffic on the network.\n \tThe CAT-DEV is accessible from other PCs on the same network.\n \t \tBecause the CAT-DEV is accessible from other PCs, other hosts may access the CAT-DEV.\n \tCommunication bandwidth may be impacted by other network traffic (such as web browsing or email) from the host PC.\n \tRequires a reserved DHCP or static IP Address\n \tSecondary Network Card \t \tIsolates the connection from LAN policies (such as disabled DHCP, forbidden broadcast traffic, or restricted unicast traffic).\n \tIsolates the connection from other network traffic.\n \tBecause the connection to the CAT-DEV is direct, communication bandwidth is maximized.\n \t \tRequires a second network card be installed in your PC.\n \tCAT-DEV is not easily accessible by other PCs.\n \tYou must ensure that the IP address of the secondary network card does not conflict with an existing IP address on the network.\n \tSetup and configuration can be convoluted.\n \tDirect Connection \t \tIsolates the connection from other network policies and traffic.\n \tDoes not require a reserved DHCP or static IP address.\n \tBecause the connection to the CAT-DEV is direct, communication bandwidth is maximized.\n \tSafest for critical operations, such as updating the firmware images of the CAT-DEV.\n \t \tThe host PC is isolated from the network and/or internet.\n \tOther PCs cannot access the CAT-DEV.\n \tSetup and configuration can be convoluted.\n Topics in This Section\n \t Using Unmanaged Switch\n \t Using Second Network Card\n \t Using Direct Connection\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228164.html","Using Unmanaged Switch",
"Using Unmanaged Switch\nHooking up Your CAT-DEV Using an Unmanaged Switch\n Note\n If you did not restart your computer after the Host Bridge setup, you will need to restart it now. Otherwise, the commands you will enter within cafex_env.bat in the next steps won't work.\n \tUsing the included CAT5 Ethernet patch cable, connect the CAT-DEV to a gigabit Ethernet switch that is also connected to your local area network (LAN). The Ethernet cable plugs into the LAN port on the front of the CAT-DEV.\n \tUsing either an HDMI cable or another supported video cable type, connect the CAT-DEV to a television.\n \tUsing the Power Cable, plug the CAT-DEV in to an electrical outlet.\n \tTurn the CAT-DEV ON by pressing the switch located on the right side of the kit.NOTE: The system will turn on into an idle state (The red OFF light will be illuminated, but the ON light will remain off). In this mode, the CAT-DEV is listening for commands from the PC, but it isn't actually running any applications.\n \tWait at least 1 minute for the CAT-DEV to receive an IP address from the network.\n \tTake note of the CAT-DEVs MAC address. This can be found on a sticker located on the left side of the CAT-DEV. This address is comprised of 12 digits (For example: 00-25-5C-BA-53-1D).\n \tOn your PC, navigate to the folder where you installed the Cafe SDK and open cafex_env.bat\n \tTypefindbridge -alland hit enter. This will search your network for any and all CAT-DEVs.When complete, a list of all connected CAT-DEVs will be displayed along with their assigned IP Address. By default, the system's Bridge Name is its MAC Address.\nNOTE: The Bridge Name can later be changed to a name or number you prefer in the MION page, explained further below.\n \tOpen a web browser and enter the IP Address for the CAT-DEV into the address bar, then press enter. If your network is set up properly, your browser should connect you to the MION Board Configuration page.\n \tClick \"Parameters Setup\". On this page, you can adjust the various settings of your CAT-DEV.\nNOTE: You can set the CAT-DEV to have a Static IP Address by specifying the address you want the system to have in the \"IP Address\" field. Then turn the DHCP setting to OFF.\nYou can also change the Bridge Name at the bottom of this page by editing the \"Device Unique\" field.\n \tClick the 'Write' button at the bottom of the page to save any changes.NOTE: If you changed any IP-related settings that cause the CAT-DEV to no longer be accessible (including changing the IP Address), you will receive a \"Page cannot be displayed\" error message after selecting 'Write'. The saved changes did take effect. The error message is the result of the CAT-DEVs IP Address being changed and therefore needing to be updated in the address bar, or another network change was made that requires the settings be changed on the PC as well.\nIf you're having trouble with the network setup, you may find it helpful to be able to reset the CAT-DEV configuration to its default factory settings. See Reinitializing the CAT-DEV Settings.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228167.html","Using Second Network Card",
"Using Second Network Card\nHooking up Your CAT-DEV Using a Second Network Card\nUsing a second network card will require setting up a Static IP for the connection between your PC and your CAT-DEV. Because the CAT-DEV uses DHCP by default , you will need to disable this first.\n Note\n If you did not restart your computer after the Host Bridge setup, you will need to restart it now. Otherwise, the commands you will enter within cafex_env.bat in the next steps won't work.\n \tConfigure your PC settings so that your Second Network connection is using DHCP.a. On your PC, open the Control Panel. Click 'Network and Internet', and then select 'Network Connection'.\nb. Right-click the connection icon that the CAT-DEV is connected to, and then select 'Properties'.\nc. Double click Internet Protocol Version 4 (TCP/IPv4).\nd. Select \"Obtain an IP address automatically\".\n \tUsing the included CAT5 Ethernet patch cable, connect the CAT-DEV to the second network port on your PC. The Ethernet cable plugs into the LAN port on the front of the CAT-DEV.\n \tUsing either an HDMI cable or another supported video cable type, connect the CAT-DEV to a television.\n \tUsing the Power Cable, plug the CAT-DEV into an electrical outlet.\n \tTurn the CAT-DEV ON by pressing the switch on the right side of the kit. The system will turn on into an idle state (The red OFF light will be illuminated, but the ON light will remain off). In this mode, the CAT-DEV is listening for commands from the PC, but isn't actually running any applications.\n \tWait at least 1 minute for the CAT-DEV to receive an IP address from the network.\n \tNote the CAT-DEVs MAC address. This can be found on a sticker that is located on the left side of the CAT-DEV. It is an address comprised of 12 digits (. For example: 00-25-5C-BA-53-1D).\n \tOn your PC, navigate to the folder where you installed the Cafe SDK and open cafex_env.bat.\n \tAt the prompt, type \"findbridge -all\" (without quotes) and hit enter. This will search your network for any and all CAT-DEVs.When complete, a list of all connected CAT-DEVs will be displayed along with their assigned IP Address. By default, the system's Bridge Name is its MAC Address.\nNOTE: The Bridge Name can later be changed to a name or number you prefer in the MION page, explained further below.\n \tEnsure that the connection settings for your CAT-DEVs connection have an IP address in the same subnet as the CAT-DEV.a. On the host PC, select Start, then select Control Panel, select Network and Internet, and finally select Network Connection.\nb. Right-click the Connection icon that the CAT-DEV is connected to. Now select Properties.\nc. Double-click Internet Protocol Version 4 (TCP/IPv4).\nd. Click 'Use the following IP Address', and then type in a IP Address and subnet mask in the appropriate text boxes.\nNOTE: The IP Address must be a unique IP Address in the same subnet as the CAT-DEV.\n \tTurn off DHCP and set up the CAT-DEV with a Static IP Address:Open a web browser and enter the IP Address you received for the CAT-DEV into the address bar. Now press Enter.\nNOTE: If your network is set up properly, your browser should connect you to the MION Board Configuration page.\n \tOn the MION Board Configuration page, click 'Parameters Setup'.NOTE: On this page, you can adjust the various settings of your CAT-DEV.\n \tType the static IP Address that you would like to assign for the CAT-DEV in the IP Address text box. Now set DHCP to OFF.\nNOTE: You can also change the Bridge Name at the bottom of this page by editing the \"Device Unique\" field.\n \tScroll to the bottom of the page and click 'Write' to save your changes.NOTE: If you changed any IP-related settings that cause the CAT-DEV to no longer be accessible (including changing the IP Address), you will receive a \"Page cannot be displayed\" error message after selecting 'Write'. The saved changes did take effect. The error message is the result of the CAT-DEVs IP Address being changed and therefore needing to be updated in the address bar, or another network change was made that requires the settings be changed on the PC as well.\n \tOn the host PC, set up a Static IP Address for the Network Connection that is connected to the CAT-DEV.a. On the host PC, click Start, select Control Panel, then select Network and Internet, and finally select Network Connection.\nb. Right-click the Connection icon that the CAT-DEV is connected to, and then click Properties.\nc. Double-click Internet Protocol Version 4 (TCP/IPv4).\nd. Click 'Use the following IP address', and then type an IP address (unique from the CAT-DEV) and subnet mask (this must be the same subnet mask as what the CAT-DEV is using) in the appropriate text boxes.\nFor example:\n IP Address: 192.168.10.10\n Subnet Mask: 255.255.255.0\n Default Gateway: 192.168.10.1\n \tConfirm that your network connection is valid by connecting to the MION page again. If this is successful, you can now move on to setting your CAT-DEV as the default device.\nIf you're having trouble with the network setup, you may find it helpful to be able to reset the CAT-DEV configuration to its default factory settings. See Reinitializing the CAT-DEV Settings.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228181.html","Using Direct Connection",
"Using Direct Connection\nConnecting to Your CAT-DEV Using a Direct Connection\n Note\n If you did not restart your computer after the Host Bridge setup, you will need to restart it now. Otherwise, the commands you will enter within cafex_env.bat in the next steps won't work.\n \tConfigure your PC settings so that your Network connection is using DHCP.a. On your PC, open the Control Panel. Click 'Network and Internet', and then select 'Network Connection'.\nb. Right-click the connection icon that the CAT-DEV is connected to, and then click Properties.\nc. Double click Internet Protocol Version 4 (TCP/IPv4).\nd. Click Obtain an IP address automatically.\n \tUsing the included CAT5 Ethernet patch cable, connect the CAT-DEV to your PC. The Ethernet cable plugs into the LAN port on the front of the CAT-DEV.\n \tUsing either an HDMI cable or another supported video cable type, connect the CAT-DEV to a television.\n \tUsing the Power Cable, plug the CAT-DEV in to an electrical outlet.\n \tTurn the CAT-DEV ON by pressing the switch on the right side of the kit. The system will turn on into an idle state. In this mode, the CAT-DEV is listening for commands from the PC, but isn't actually running any applications.NOTE: The red OFF light on the front of the system, will be illuminated, but the ON light will remain off.\n \tWait at least 1 minute for the CAT-DEV to receive an IP address from the network.\n \tTake note of the CAT-DEVs MAC address, which can be found on a sticker that is located on the left side of the CAT-DEV. It is an address comprised of 12 digits. For example: 00-25-5C-BA-53-1D\n \tOn your PC, navigate to the folder where you installed the Cafe SDK and open cafex_env.bat\n \tTypefindbridge -alland hit Enter. This will search your network for any and all CAT-DEVs.When complete, a list of all connected CAT-DEVs will be displayed along with their assigned IP Address. By default, the system's Bridge Name is its MAC Address.\nNOTE: The Bridge Name can later be changed to a name or number you prefer in the MION page, explained further below.\n \tEnsure that the connection settings for your CAT-DEV connection has an IP address in the same subnet as the CAT-DEV.a. On the host PC, click Start, select Control Panel, then click on Network and Internet, and finally select Network Connection.\nb. Right-click the Connection icon that the CAT-DEV is connected to. Now click 'Properties'.\nc. Double-click Internet Protocol Version 4 (TCP/IPv4).\nd. Click 'Use the following IP Address'. Type an IP Address and subnet mask in the appropriate text boxes.\nNOTE: The IP Address must be a unique IP Address in the same subnet as the CAT-DEV.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228205.html","2. Setting Static IP Address",
"2. Setting Static IP Address\n 2. Setting up a Static IP Address (Recommended)\n Your system is now operational. However, it is highly recommended that you configure the CAT-DEV with a Static IP Address. This is because the IP Address may change each time the CAT-DEV is completely turned off via the Power Switch.\n \tOpen a web browser then type the IP address you received for the CAT-DEV into the address bar. Now press Enter.If your network is set up properly, your browser should connect you to the MION Board Configuration page.\n \tOn the MION Board Configuration page, click Parameters Setup. On this page, you can adjust the various settings of your CAT-DEV.\n \tType the static IP Address that you would like to assign to the CAT-DEV into the IP Address text box. Then set the DHCP to OFF.\nYou can also change the Bridge Name at the bottom of this page by editing the \"Device Unique\" field.\n \t Scroll to the bottom of the page and click 'Write' to save your changes.\n Note\n If you changed any IP-related settings that cause the CAT-DEV to no longer be accessible (including changing the IP Address), you will receive a \"Page cannot be displayed\" error message after selecting 'Write'. The saved changes did take effect. The error message is the result of the CAT-DEVs IP Address being changed and therefore needing to be updated in the address bar, or another network change was made that requires the settings be changed on the PC as well.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228207.html","Reinitializing Settings",
"Reinitializing Settings\nReinitializing the CAT-DEV Settings\n If you're having trouble with the network setup, you may find it helpful to be able to reset the CAT-DEV configuration to its default factory settings.\n To restore the CAT-DEVs configuration settings to their factory default, ensure that the CAT-DEV is idle (the Power Switch is turned ON and the OFF light is illuminated on the front on the system). Press and hold the INIT button located on the front of the system until the blue STAT light begins to blink. This will revert the settings (IP Address, DHCP, etc.) back to their default settings.\n After performing these steps, you will want to use cafex_env.bat to perform a findbridge search again. This will allow you to find out the systems new IP Address.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228209.html","3. Setting CAT-DEV as Default",
"3. Setting CAT-DEV as Default\n3. Setting up the CAT-DEV as Your Default Device\n In cafex_env.bat, enter the following command to set your CAT-DEV as the default device:\n setbridge -default <Device Name> <IP Address> Note that <Device Name> should be the name of your system as defined in the MION page. If you didn't change it, it will be the system's MAC Address.\n The <IP Address> will be whichever IP Address that was displayed when you performed the \"findbridge\" command earlier, if you did not manually configure it in the MION page.\n A message will be displayed confirming the system and address have been set. These settings will stay in effect.\n Info\n If you ever need to change these settings, you can do so by re-entering this command using the updated device name and/or IP address.\n For your reference, cafex_env.bat will show you the currently-assigned default device and IP address when you open it.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228213.html","4. Starting Up CAT-DEV",
"4. Starting Up CAT-DEV\n4. Starting up the CAT-DEV\nYou're almost done! At this point, you've got everything installed, you have hooked up the system and confirmed that your PC is able to establish a connection with the CAT-DEV across your network, and you have pointed your Cafe SDK environment to use this system. It's finally time to try and turn your system on!\nIf you were daring enough, you may have already tried to turn your CAT-DEV on by pressing the Power button on the front, only to find that the ON light blinked and nothing ever happened on your TV. This is because a CAT-DEV right out of the box isn't configured to work without being attached to a PC, and while it's possible to change this, let's not worry about that for now.\nRight now we'll start up the CAT-DEV using your PC and load the System Config Tool. This tool allows you to pair your DRC to the system, adjust system settings and other various functions.\n Info\n Unless changed, the CAT-DEV will start up with its display mode set to AUTO. This means the system will attempt to display the highest video setting possible (1080P HDMI), going down the list until it detects a valid setting. Make sure you only have the video cable you intend to use plugged into the CAT-DEV. Make sure your TV is set to the desired video option before turning the system ON.\nStarting up the CAT-DEV\n \tMake sure that your CAT-DEV Power Switch is flipped on. The red OFF light will be illuminated. Wait for the blue STAT light to be illuminated. This symbolizes that the system is idle and listening for commands.\n \tOn your PC, navigate to the folder you installed the Cafe SDK to and open cafex_env.bat\n \tType \"cafex on\" (without quotes) and hit enter.The blue ON light should come on and the Wii U logo will appear on the TV screen. After a few seconds, you will see the System Config Tool.\n \tGo ahead and take a minute to cheer and pat yourself on the back.\n This program can be navigated with a variety of controller types:\n \tDRC (once paired with the system)\n \tWii Remote (Which can be synced by pressing the Sync button on the front of the CAT-DEV as well as on the remote)\n \tWii Classic Controller Pro (plugged directly into the CAT-DEV's 'Classic CON' port)\n \tUSB Keyboard plugged into the CAT-DEV\n \tYour PC Keyboard (as long as the Cafe SDK window is the active window)\n The application may start in Japanese by default. Use any of the above controller options to highlight the fourth option (Language will be displayed in English as well), press the A Button to select the option and then move Up or Down to pick your desired language.\n Be sure to read Basic Commands for the CAT-DEV to see how to shut off your devkit, etc.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228218.html","5. Connecting and Pairing DRC",
"5. Connecting and Pairing DRC\n5. Connecting and Pairing Your DRC\nThe DRC provided to you has the option of working wirelessly or using a coaxial cable to provide a wired connection. The wired connection acts as an antenna and is useful for environments where there is a lot of wireless noise, or if you have many systems in a close proximity. It does not provide power to or automatically sync the DRC.\n \t(Wired Only) Using the included coaxial cable, connect the DRC to the DRC1 port on the Right Side of the CAT-DEV.\n \tSet the DRC switch on the Front of the system to your preferred choice.\nThe BT switch is for Bluetooth connections. Set this to Wireless, as this setting will only affect the controllers that use Bluetooth, such as the Wii Remote Controller and the Wii Balance Board. Having this switched to Wired will make it more difficult to sync those types of controllers.\n \tOn the DRC itself, set the switch to your preferred settings.\n \tHolding down the L and ZL Buttons at the same time, press the Power button on the DRC. This will open the DRC's settings menu (DK Menu). Now select 'System Settings'.\n \tUsing Left or Right on the + Control Pad, select either Wired or Wireless. Press the B Button and select 'Exit' when you're finished.\n \tIn the System Config Tool on the CAT-DEV, select Wii U GamePad (DRC) Setting.\n \tSelect Pair DRC. A display box will appear that shows a four character PIN Code.\n \tWhile the PIN code is displayed on the screen, power on your DRC by pressing the Power Button located on controller.A Nintendo racetrack logo will appear. Press the small red Sync button on the back of the DRC, just below the battery cover. You may want to use the Wii U Gamepad's Stylus to accurately press the sync button.\n \tAfter pressing the Sync button, the DRC will display a PIN entry screen. Enter the same PIN that is displayed on your Television.NOTE: Depending on the firmware installed on the GamePad, the DRC screen may have a 10-digit keypad rather than the four symbols. In this case, enter the PIN code displayed in the parenthesis to the right of the symbol PIN code displayed on-screen.\nIf the pairing fails, ensure that the Wired/Wireless settings are set correctly. Also, if you are using a wired connection, be sure that the coaxial cable is tightly attached.\nIf the DRC is paired, the 'Firmware Version' field will display the version information of both the DRH (the CAT-DEV-side of the connection) and the DRC itself. If no DRC is attached then only the DRH information will be displayed.\n \tIf the DRC is attached and there is an update to the firmware available, an option to update the firmware will be displayed.\nSelect the Update DRC firmware option to update the firmware on the DRC. A progress bar will appear displaying the update progress. Be sure that the DRC is not low on battery power when updating.If your DRC displayed the number pad when pairing, this firmware update will take a bit longer than normal. The progress bar will reach 100%, but it will take a little while longer before control is regained. You will also need to re-pair the DRC after this update, as the update will break the pairing connection.\nThe amount of time necessary to perform the update may vary. A normal update will only take a couple of minutes and would not require pairing the DRC again. In this specific case, the update may take around 10 minutes to complete.\n \tIf listed, select Update WOWL Firmware as well. This is a short update that will disappear when complete.At this point, your DRC should now be paired and up-to-date!\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228230.html","Updating CAT-DEV",
"Updating CAT-DEV\nUpdating a CAT-DEV System\nYou can update to a newer CAT-DEV system firmware in a few simple steps. These same steps can also be used to downgrade your system.\nTopics in This Section\n \t 1. Preparation\n \t 2. Running System Updater\n \t 3. Updating GamePad Firmware\n \t 4. Updating Host Bridge\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228234.html","2. Running System Updater",
"2. Running System Updater\n2. Running the System Updater\n \tOn your PC, open the newly-installed SDK folder and run cafex_env.bat.\n \tType 'cafex update' and hit enter. The system will turn on and begin the update process. When the update is finished, the HOME menu placeholder will appear on the screen, and the cafex_env.bat session will break, allowing you to enter commands.\n \tEnter 'cafex stop' to properly turn off the system.Improperly shutting off the system by using the power button may cause another system update to occur if you used the 'cafex on' command (normally used to start the System Config Tool). Using 'cafex stop' will prevent this.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228239.html","3. Updating GamePad Firmware",
"3. Updating GamePad Firmware\n3. Updating the DRC (GamePad) Firmware\nAs new SDKs are released, revisions may be made to the DRC firmware as well. DRC firmware updates are performed using the System Config Tool.\n \tAfter updating your CAT-DEV, load the System Config Tool by opening cafex_env.bat and entering the command 'cafex on'.\n \tNavigate to the 'Wii U GamePad (DRC) Setting' submenu.\n \tSelect to update the firmware (if applicable).\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228246.html","4. Updating Host Bridge",
"4. Updating Host Bridge\n4. Updating the Host Bridge (if applicable)\nThe NDI Installer does not update the Host Bridge firmware on the devkit. It will install the Host Bridge software, but it skips the firmware update. You must update this manually.\n \tRun the Host Bridge Setup installer software. When prompted that a version already exists on your PC, elect to install the newer version.\n \tWith your CAT-DEV idle (Power Switch ON but the OFF light illuminated), check the box to update your bridge firmware.\nThis is referring to the firmware on the CAT-DEV itself. Enter the IP Address manually or select the system from the pull-down menu.The firmware update will take a minute or two, and will display a message will completed.\nNote\nDuring this process, the CAT-DEV will disconnect and reconnect to the PC. If your CAT-DEV is set to use DHCP, the IP reassignment may cause the reset process to take longer. The reassignment may take so long that there may be an error that the bridge did not respond. If this happens, try again. If it persists, switch to using a static IP.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228253.html","4. Verifying Your Environment",
"4. Verifying Your Environment\n 4. Verifying Your Environment is Setup Right\nBefore developing with Unity for Wii U, you should create and build an empty project to make sure your development environment is set up correctly.\n \t Start Unity and create a new project.\n \t From the File menu, select Build Settings.\n \t Under Platform, scroll down to select Wii U and then click Switch Platform.\n \t Select the Development Build option. Click Build.\n \t You will be prompted to select a build directory. We recommend you choose a location outside of the project folder. Specify the location and click Select Folder.\n \t If your environment is set up correctly, the project should start building.\n \tIf your build finished with no errors, you are done. Congratulations! However, if your project failed to build, be sure to check out the section on common Unity Editor errors and solutions for additional troubleshooting.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228307.html","Unity for Wii U Basics",
"Unity for Wii U Basics\nUnity for Wii U Basics\nUnity for Wii U includes a number of platform-specific features. This tutorial covers some of the basic steps that are required when creating a project for the Wii U system. We recommend working through these lessons first, because many of the later tutorials use the scenes described here as a starting point.\nYou can download a completed version of the project created in this guide below.\n \tProject \tDescription\n \t WiiU_BasicStarterProject.zip \tThis project has two cameras (one for the TV and one for the GamePad) and is set up to build for the Wii U.\nTopics in This Section\n \t Setting the Build Platform\n \t Setting Up Two Cameras\n \t Coding for Multiple Platforms\n \t Audio on the Wii U GamePad\n \t Importing the Audio Assets\n \t Setting up the AudioSouce\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228312.html","Setting the Build Platform",
"Setting the Build Platform\nSetting the Build Platform to Wii U\nBefore you can begin setting up the Unity Editor for Wii U development, you must set the build platform to Wii U. This exposes a number of Wii U-specific options in the Unity Editor.\n Info\n The completed project can also be downloaded from the Unity for Wii U Basics page.\nUse the following procedure to set the build platform to Wii U.\n \tSelect File > Build Settings to open the Build Settings window.\n \t Under Platform, select Wii U, click Switch Platform and then close the Build Settings window.\n Note\n If you do not see the Wii U option, make sure you entered the serial number provided in the Unity for Wii U description in Nintendo Dev Interface. The serial number can also be found in the description of the Unity for Wii U download on the Nintendo Developer Portal Downloads page.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228329.html","Setting Up Two Cameras",
"Setting Up Two Cameras\nSetting Up Two Cameras\nThe Unity Camera component includes an extra Target Display option when the build platform is set to Wii U. This option is set to TV by default. To display something else on the Wii U Gamepad, another camera must be set up.\nAdding a Second Camera\nThe following procedure describes the required steps for adding a second camera for the lower screen.\n Info\n The completed project can also be downloaded from the Unity for Wii U Basics page.\n \tIn the Hierarchy pane, select Create > Camera to add a second camera.\n \tSelect the newly added Camera object and in the Inspector pane, set the Target Display option to GamePad.\n \tEach scene can only have one Audio Listener component. Select one of the cameras to remove the Audio Listener from, right-click the component, and select Remove Component in the context menu.\n \tConfigure and position the camera as desired in the scene.\n \t You can change the target display through script:\n \t GetComponent<Camera>().targetDisplay = WiiU.displayIndex.TV;\n \tThe three dashed bars in the unity editor let you add more windows; one of which could be a second Game window for a dedicated GamePad screen.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228333.html","Coding for Multiple Platforms",
"Coding for Multiple Platforms\nCoding for Multiple Platforms\nCertain platforms require specific function calls that are unique to that particular system. If you are developing a game for multiple platforms, you need a way to tell the compiler not to include the code for non-compatible platforms. Unity provides a number of platform defines that can be used with preprocessor directives to limit certain blocks of code to specific platforms.\n Info\n A full list of platform defines is available in the Unity Manual under Scripting > Scripting Overview > Platform Dependent Compilation.\nWii U-Specific Code\nIf you build for platforms other than the Wii U, calls to the Wii U API will cause errors that will stop your build. You can prevent this by using #if and #endif statements around your Wii U-specific code.\n \t #if UNITY_WIIU\n // Wii U-specific code here\n#endif\n Excluding Code in the Unity Editor\n Sometimes you also don't want Wii U code to run when you are testing a Wii U game inside the Unity Editor (testing on the PC). Code for unusable features on the PC (such as for Wii Remote input and sensor data) will not throw errors, so you don't need to give this special attention. However, Wii U-specific networking code will cause problems, so in this case you should set it to only be compiled for when you run it on the devkit. You can do this with the following preprocessor directives.\n \t #if UNITY_WIIU && !UNITY_EDITOR\n // Wii U-specific code here\n#endif\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228336.html","Controllers and Input",
"Controllers and Input\nControllers and Input\nThe Wii U supports the GamePad along with four channels for additional controllers, giving you support for five players. The supported controllers are as follows:\n \tGamePad\n \tWii Remote and Wii Remote Plus\tMotionPlus (Wii Remote attachment)\n\tNunchuk (Wii Remote attachment)\n\tClassic Controller (Wii Remote attachment)\n\tClassic Controller Pro (Wii Remote attachment) *\n \tPro Controller *\n \tBalance Board\n Note\n The Pro Controller and Classic Controller Pro are commonly confused. The Classic Controller Pro plugs into a Wii Remote, and the Pro Controller is a stand alone unit with it's own batteries that are charged via USB cable. The button layout is the same, but getting input from them is different.\nThere are two main ways to get input from controllers:\n InputManager\nThe InputManager is the simplest to use, but it only reads button/joystick input from the GamePad and Pro Controllers. To access the accelerometer, gyroscope, etc. or to support the Wii Remote or Balance Board, you must directly use the Wii U API. Using Input Manager is the same for both Unity 4.x and Unity 5.x.\n Wii U API\nThis is more complex than using the InputManager, but the API gives you access to all sensor data and supports all controllers.\nInput for the GamePad touch screen is different and is handled in its own section.\n Info\n Here are some guideline considerations to follow for any text or pictures in your game relating to controllers:\n \tIf you refer to the controllers in the game, be sure to consult to the Wii U Terminology Hardware-Related Terms document to see what terms are acceptable. Using an incorrect term will cause your game to fail Lotcheck.\n \tIf you want to put pictures of supported controllers in your game, see the Wii U Artwork Collection - Application Development document.\nTopics in This Section\n \t Setting up Additional Controllers\n \t Using InputManager\n \t Using the Wii U API\n \t GamePad Touch Screen Input\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228338.html","Setting up Additional Controllers",
"Setting up Additional Controllers\nSetting up Additional Controllers\nThe GamePad can be used without any prior set up, but all other controllers require changing settings inside the Unity Editor before you can use them in your game.\nSetting up Additional Controllers\n \tGo to Edit > Project Settings > Player from the main menu.\n \tClick on the ‘U’ logo for the Wii U in the Inspector.\n \tIn Other Settings, scroll down to Enabled Wii Controllers.\n \tFor Wii Remote Count, enter the number of controllers in addition to the GamePad that you want to all to connect to the Wii U (acceptable values are 0-4). Wii Remote accessories do not count. The Pro Controller and the Balance Board each count as one remote.\n \tCheck the box for each type of accessory you would like to use.\n Info\n \tYou can sync controllers to your devkit either in game or anytime while the System Config Tool is running.\n \tIf you mark in the Unity editor that your game supports a controller, you must also make note of that in your submission documents when submitting your game to Lotcheck.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228341.html","Using InputManager",
"Using InputManager\nUsing InputManager\n Note\n The Pro Controller ZR button does not work with InputManager. This is a known bug. If you plan to use this button on the Pro Controller, use the Wii U API instead of using the InputManager.\nThere are two types of controls: joysticks and buttons. The settings for each of them are very different. InputManager calls the button mapping entries ‘axes’ (plural for axis). This gets confusing because there is also a setting for axis (as in x/y axis). To ease confusion, in this guide I’ll just call each button mapping ‘axes’ an entry.\nJoysticks\nThis image shows how to set up the left joystick on the GamePad. Relevant settings are in the green boxes. Settings marked by red boxes are ignored for buttons and have no effect on behavior.\nSettings:\n Type: This is always ‘Joystick Axis’\n Axis: This is divided by the X/Y axis for the left and right joystick.\n \tX axis = x axis of the main joystick (left joystick)\n \tY axis = y axis of the main joystick (left joystick)\n \t3rd axis = x axis of the right joystick\n \t4th axis = y axis of the right joystick\n Joy Num: Set this according to the numbers given below.\n \tJoystick 2: GamePad.\n \tJoystick 3-6: Pro Controller. Joystick 3 does not relate to the player number. It only means the first Pro Controller. If player 1 and 3 use Wii remotes, and player 2 and 4 use Pro Controllers, the Pro Controllers will be on Joystick 3 and Joystick 4.\n \tGet Motion from all Joysticks: takes input from the GamePad and all connected Pro Controllers at the same time. This is not recommended.\nButtons\nThis image shows how to set up the A button on the GamePad. Relevant settings are in the green boxes. Settings marked by red boxes are ignored for buttons and have no effect on behavior.\nTo reference a button, enter the joystick number along with the button number. You can find the full list of button numbers in the Unity for Wii U documentation. For Unity 5.x, this is in Platform Specific > Wii U > Wii U Scripting > Wii U Joystick Aliases and Axes.\nExample for the B button on the GamePad:\nPositive Button: joystick 2 button 1\nType: Key or Mouse Button\nExample for ‘up’ on the +Control Pad on the first Pro Controller:\nPositive Button: joystick 3 button 12\nType: Key or Mouse Button\nNote that you can assign both keyboard key presses and GamePad button presses to the same entry. The above image uses these settings to assign one entry to both the A button and the ‘a’ key:\nPositive Button: joystick 2 button 2\nAlt Positive Button: a\nType: Key or Mouse Button\nSetting an alternate button to a keyboard key allows you to test your game more easily in the Unity Editor. Joystick input and key presses cannot be placed in the same entry, but you can make two entries with the same name to get the same results. For example:\n Entry 1\nName: gamePadLeftJoyX\nType: Joystick Axis\nAxis: X axis\nJoy Num: Joystick 2\n Entry 2\nName: gamePadLeftJoyX\nPositive Button: up\nNegative Button: down\nType: Key or Mouse Button\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228346.html","Using the Wii U API",
"Using the Wii U API\nUsing the Wii U API\nWhen using the Wii U API provided with Unity to get input for controllers, there are four things you must always do:\n \tImport the API module\n \tCreate an object to access the controller\n \tGet the state object of the controller\n \tCheck for a specific state\nYou must get the new state of the controller every time before you check for button presses, etc. This is generally done every cycle in Update(). Also note that the Balance Board and Pro Controller API is built on the Wii Remote API. If there is a function that you cannot find in the Balance Board or Pro Controller API, you may be able to use the Wii Remote API. An example would be that you can check to see if a Pro Controller is out of batteries using UnityEngine.WiiU.Remote.status.\nCode samples are given for the following:\n \tGamePad\n \tWii Remote\n \tMotionPlus\n \tNunchuk\n \tClassic Controller and Classic Controller Pro*\n \tPro Controller*\n \tKnowing What Controller is Connected\n Note\n The Pro Controller and Classic Controller Pro are not the same controller. The Classic Controller Pro plugs into a Wii Remote, and the Pro Controller is a stand alone unit with it's own batteries that are charged via USB cable. The button layout is the same, but getting input from them is different.\nGamePad\nUsing the GamePad API, you have access to sensor data, button presses, error statuses and more. See WiiU.GamePadState in the Unity for Wii U Scripting API for a list of all functions. The sample below shows how to implement some of them. For touch input, see the GamePad Touch Screen Input tutorial page.\n \t1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16\n17\n18\n19\n20\n21\n22\n23\n24\n25\n26\n27\n28\n29\n30\n31\n32 \t using UnityEngine;\nusing WiiU = UnityEngine.WiiU;\npublic class gamePadInputTest : MonoBehaviour\n{\n WiiU.GamePad gamePad;\n void Start()\n {\n // Create a GamePad object\n gamePad = WiiU.GamePad.access;\n }\n void Update()\n {\n // Get the new state of the GamePad\n WiiU.GamePadState gamePadState = gamePad.state;\n if (gamePadState.gamePadErr == WiiU.GamePadError.None)\n {\n // Check for the A button\n if (gamePadState.IsTriggered(WiiU.GamePadButton.A))\n {\n // The A button was pressed\n }\n // Read data from the gyroscope\n Vector3 gyroData = gamePadState.gyro;\n // Read data from the left stick\n Vector2 leftStick = gamePadState.lStick;\n }\n }\n}\n Wii Remote\nIf you don't enable the MotionPlus features of a Wii Remote Plus, it acts as a regular Wii Remote. The following code shows how to set up two Wii Remotes.\n \t1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16\n17\n18\n19\n20\n21\n22\n23\n24\n25\n26\n27\n28\n29\n30\n31\n32\n33\n34\n35\n36\n37\n38\n39\n40\n41\n42 \t using UnityEngine;\nusing WiiU = UnityEngine.WiiU;\npublic class wiiRemoteInputTest : MonoBehaviour\n{\n WiiU.Remote remote0;\n WiiU.Remote remote1;\n  void Start()\n {\n // Create Wii Remote objects using channel 0 and channel 1\n remote0 = WiiU.Remote.Access(0);\n remote1 = WiiU.Remote.Access(1);\n }\n void Update()\n {\n // Get the new state of the controllers\n WiiU.RemoteState r0State = remote0.state;\n WiiU.RemoteState r1State = remote1.state;\n // Check for input from player 1\n if (r0State.err == WiiU.RemoteError.None)\n {\n if (r0State.IsTriggered(WiiU.RemoteButton.A))\n {\n // The player 1 A button was pressed\n }\n // Get the orientation of the controller\n Vector3 r0Acc = r0State.acc;\n }\n // Check for input from player 2\n if (r1State.err == WiiU.RemoteError.None)\n {\n if (r1State.IsTriggered(WiiU.RemoteButton.A))\n {\n // The player 2 A button was pressed\n }\n }\n }\n}\n MotionPlus\n Note\n If you enable MotionPlus, other Wii Remote attachments (classic controller, nunchuk) will not work. This is due to a limitation in Unity.\nThere are extra steps to detect if a Wii Remote has MotionPlus features and to enable them. You can initially enable MotionPlus before the controller is on, but if the user disconnects/reconnects the MotionPlus attachment, you need to disable/re-enable MotionPlus. You can check if MotionPlus is connected by using the MotionPlus remote mode (see sample below) occasionally. Calling this function too often can cause problems with the Wii Remote, such as sound from the Wii Remote might stop playing, so we recommend not checking every frame. Leaving motion plus on consumes the battery faster. It is prohibited to turn on MotionPlus in applications that don't use it.\nThis code sample builds on what was used in the Wii Remote sample.\n \t1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14 \t // Create a MotionPlus object\nWiiU.MotionPlus mpRemote0 = remote0.motionPlus; // Using remote0 from the Wii Remote sample\n// Enable MotionPlus\nmpRemote0.Enable(WiiU.MotionPlusMode.Standard);\n// Check if the MotionPlus attachment was removed (every several frames)\nif (mpRemote0.mode == WiiU.MotionPlusMode.Off)\n{\n // Alert the user to connect MotionPlus, and wait for them to do so, or disable MotionPlus\n mpRemote0.Disable();\n}\n// Get the 3D attitude of the X axis\nVector3 xAttitude = r0State.motionPlus.dir.X;\n Nunchuk\nUsing the Nunchuk is simple, but the API for it is split between WiiU.RemoteState (for buttons) and WiiU.RemoteState.nunchuk (for joystick and sensor data). Buttons are the WiiU.RemoteButton type. The following code can be added to the above Wii Remote sample code.\n \t1\n2\n3\n4\n5\n6\n7 \t if (r0State.IsPressed(WiiU.RemoteButton.NunchukC)) // Using remote0 from the Wii Remote sample\n{\n // The C button was pressed\n}\n// Get input from the nunchuk joystick\nVector2 nunchukStick = r0State.nunchuk.stick;\n Classic Controller and Classic Controller Pro\nThe Classic Controller and Classic Controller Pro are the same controller with a different shape, so the API calls are the same. All button presses and joystick data are available from WiiU.RemoteState.classic, and the buttons are the WiiU.ClassicButton type.\n \t1\n2\n3\n4\n5\n6 \t if (r0State.classic.IsPressed(WiiU.ClassicButton.A)) // Using remote0 from the Wii Remote sample\n{\n // The A button on the Classic Controller was pressed\n}\n// Get input from the left joystick\nVector2 r0LeftStick = r0State.classic.leftStick;\n Pro Controller\nPro Controller input is similar to input for Classic Controllers. All button presses and joystick data are available from WiiU.RemoteState.pro, and the buttons are the WiiU.ProControllerButton type. The initial setup is the same as with Wii Remotes.\n \t1\n2\n3\n4\n5\n6 \t if (r0State.pro.IsPressed(WiiU.ProControllerButton.A)) // Using remote0 from the Wii Remote sample\n{\n // The A button on the Pro Controller was pressed\n}\n// Get input from the left joystick\nVector2 r0LeftStick = r0State.pro.leftStick;\n Knowing What Controller is Connected\nThere are two ways to tell what controller is connected, either with WiiU.RemoteState.devType or WiiU.Remote.Probe(). They both give the same, up-to-date results, but RemoteState.devType is far simpler to use. It returns a WiiU.RemoteDevType. See the Unity API for a full list of the devTypes.\n \t1\n2\n3\n4 \t if (r0State.devType == WiiU.RemoteDevType.Nunchuk) // Using remote0 from the Wii Remote sample\n{\n // The nunchuk is attached\n}\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228348.html","GamePad Touch Screen Input",
"GamePad Touch Screen Input\nGamePad Touch Screen Input\nThere are three ways to get touch screen input.\n \tAs mouse input\n \tAs touch input\n \tUsing the Wii U API\nThe y-axis is inverted for the first two, so the coordinates for the top left corner of the touch screen are as follows:\n \tAs mouse input: (0, 480)\n \tAs touch input: (0, 480)\n \tUsing the Wii U API: (0, 0)\nAs Mouse Input\nThe easiest way is to treat touch screen input as mouse input, but the Wii Remote on channel 0 (the first player) also uses Input.GetMouseButton(0) (for the A button) and Input.mousePosition (for the pointer). However, Input.mousePosition returns the coordinates for the TV, not the GamePad, and in a different scale. You can disable the Wii Remote pointer with UnityEngine.WiiU.Remote.DisableDPD(). This will stop both Input.GetMouseButton(0) and Input.mousePosition from responding to Wii Remote input. Another option is to use one of the other methods to get touch input.\n \t1\n2\n3\n4\n5\n6 \t Vector3 touchPosition;\nif (Input.GetMouseButton(0)) {\n // A touch was registered\n // Get the location of the touch\n touchPosition = Input.mousePosition;\n}\n As Touch Input\nThis is very similar to mouse input. The Wii U only supports one touch at a time, so you only ever need to check Input.touches[0].\n \t1\n2\n3\n4\n5\n6 \t Vector2 touchPosition;\nif (Input.touchCount > 0){\n // A touch was registered\n // Get the location of the touch\n touchPosition = Input.touches[0].position;\n}\n Using the Wii U API\nThis method is slightly more complicated, but is easy to use if you are already using the Wii U API for the GamePad buttons, joysticks or sensors. After creating a GamePad object, you must get a new WiiU.GamePadState every time you want to read input.\n \t1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16\n17\n18\n19\n20\n21\n22\n23 \t using UnityEngine;\nusing WiiU = UnityEngine.WiiU;\npublic class gamePadInputTest : MonoBehaviour\n{\n WiiU.GamePad gamePad;\n void Start()\n {\n // Create a GamePad object\n gamePad = WiiU.GamePad.access;\n }\n void Update()\n {\n // Get the new state of the GamePad\n WiiU.GamePadState gamePadState = gamePad.state;\n if (gamePadState.gamePadErr == WiiU.GamePadError.None)\n {\n  // Get the touch position\n Vector2 touchPosition;\n touchPosition.x = gamePadState.touch.x;\n touchPosition.y = gamePadState.touch.y;\n }\n }\n}\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228396.html","2. Installing Required Software Packages",
"2. Installing Required Software Packages\n2. Installing Required Software Packages\nUse Nintendo Dev Interface (NDI) to download and install the software packages required for setting up the Wii U development environment. Follow the steps below to acquire the required packages.\n \t Start NDI.\n \tOn the Welcome screen, select the Dev Environments option.\n \tOn the Development Environments screen, select Install New.\n \tOn the Install New Environment screen, select Create My Own.\n \t On the Environment Destination screen, select Install to Disk.\n \tIf this is your first time running NDI, you will be asked to select a server and enter your Nintendo Developer ID. Set Server to Nintendo Developer Portal and Nintendo Developer ID to your NDID and click Connect.\n \tYou will then be prompted for your password. Enter your password and click Log In.\n \t Next, select where to install the development environment. Set Location to a suitable directory on your hard drive without any spaces in the path. In this guide, we will use C:\\NDI.\n Note\n Never use spaces in any of the directory names for your development environment. It will cause numerous problems.\n \t Set Name to a suitable environment name without any spaces and click Next. In this guide, we will use WiiU. This results in a root environment directory of C:\\NDI\\WiiU.\n \t On the Define New Environment screen, set Platform to Wii U and confirm that Tool Set is set to Stand-alone SDK and SDK is set to Wii U.\n \t On the Select SDK Version screen, choose the version of CAFE-SDK that matches the version of Unity you want to use (you can find which SDK versions match to which Unity versions using the version table on Nintendo Developer Portal). Click Next.\n Note\n If you select an SDK with no supported versions of Unity, you will not be able to see the Unity package to download. Be sure to select the correct SDK version.\n \t Next, we choose which software packages to install. In the bottom-right corner of the Configure Environment screen, select Customize Selection.\n \t In the search box, type Unity and press Enter.\n Note\n If no version of Unity is found, then you have selected a version of the SDK with no supported versions of Unity. See the Middleware Version Table for what versions of the SDK are supported by the different versions of Unity for Wii U.\n \t For the CAFE - MW - Unity SDK entry, select the Unity version you want to install and click Show More to display the release notes for that version.\n \t Make note of the serial key in the release notes as well as the supported HostBridge Software version and then click Done. You will need this key when installing Unity.\n \t Click Install. The following packages will automatically be installed as well.\n \tPackage \tVersion\n \tCAFE - HostBridge Software \tVersion specified in the download description of the Unity for Wii U package.\n \tCAFE - MULTI License \tLatest version\n \tCAFE - GHS MULTI \tLatest version\n The process is automated, but some windows will open and close during installation.\n \tOnce the installation process is complete, navigate to the root directory of the environment (in this guide, it would be C:\\NDI\\WiiU) and run the SetupEnvironment.wsf file to add the required environment variables.\n \tYou must also set the GHS_ROOT environment variable to point to the GHS MULTI installation.\n\tThe default install directory is c:\\ghs\\multi. Navigate to that directory to be sure MULTI was installed there.\n\tOpen an MS-DOS command prompt and type in the following:\nsetx GHS_ROOT <GHS MULTI install directory>\nIf GHS MULTI was installed via the standard settings, the command would look like this:\nsetx GHS_ROOT c:\\ghs\\multi\n\tPress enter. You should get a response stating the variable was saved.\n \tRestart your Window's session (log out and log back in).\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228401.html","Using Development Hardware",
"Using Development Hardware\nUsing Development Hardware\nThere are two devkits for the Wii U: the CAT-DEV and CAT-R. For a comparison between the two, see What Devkit Should I Buy?\nFor setting up and using the CAT-DEV, see these sections first:\n \t Setting up the CAT-DEV Development Kit\n \t Connecting Your Devkit to the Internet\n \t Running Your Game on a Wii U Devkit\nFor setting up and using the CAT-R, see these sections first:\n \t Setting up the CAT-R Development Kit\n \t Connecting Your Devkit to the Internet\n \t Running Your Game on a Wii U Devkit\nTopics in This Section\n \t Commands for CAT-DEV\n \t Connecting to the Internet\n \t Running Your Game on a Wii U Devkit\n \t Installing From SD Card\n \t Running Your Game Directly From the PC\n \t Serial Logging on CAT-R\n \t Setting up an NNID on your Devkit\n \t Setting up CAT-DEV\n \t 1. Connecting the CAT-DEV\n \t Using Unmanaged Switch\n \t Using Second Network Card\n \t Using Direct Connection\n \t 2. Setting Static IP Address\n \t 3. Setting CAT-DEV as Default\n \t 4. Starting Up CAT-DEV\n \t 5. Connecting and Pairing DRC\n \t 6. Checking if you Need to Update\n \t Reinitializing Settings\n \t Setting up CAT-R\n \t Updating Your Devkit\n \t Updating CAT-DEV\n \t 1. Preparation\n \t 2. Running System Updater\n \t 3. Updating GamePad Firmware\n \t 4. Updating Host Bridge\n \t Updating CAT-R\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228406.html","Running Your Game on a Wii U Devkit",
"Running Your Game on a Wii U Devkit\nRunning Your Game on a Wii U Devkit\nThere are two ways to load and run your Unity game on your devkit.\n \t Running Your Game Directly From the PC: This is only possible with CAT-DEV devkits. This is the easiest and fastest way, and it gives you quick access to the debug log.\n \t Installing From SD Card: This takes additional steps, but can also be used for testing mastered images (WUMADs). CAT-R devkits must always use this method.\nTopics in This Section\n \t Installing From SD Card\n \t Running Your Game Directly From the PC\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228412.html","Running Your Game Directly From the PC",
"Running Your Game Directly From the PC\nRunning Your Game Directly From the PC\nThis only works with the CAT-DEV. There are two ways to do this. Using Build and Run is more convenient, but if your game crashes while you are testing it, the output log window will close, and your output will be lost. If you want to save your output, follow the steps in Using run.cmd instead.\nUsing Build and Run\n \tTurn on your CAT-DEV (using the switch on the side of the devkit). You don't need to start it up with the \"cafex on\" command since Build and Run will start up the devkit automatically.\n \t Open your project in Unity. If this is your first time building on this PC, we recommend first testing with a new project (see Verifying Your Environment is Setup Right).\n \t From the menu bar, select File > Build Settings.\n \t Under Platform, if Wii U is not already selected, select Wii U and then click Switch Platform.\n \t Set the Build Debug Level to Development. If you are using networking features in your game, or if you are using the Unity profiler and/or script debugging, set the Build Debug Level to Development[With Network]. If not, use Development[No Network].\n \t Set the Build Output to Unpackaged.\n \t Set the Boot Mode to PCFS.\n \t Click Build and Run.\n \t You will be prompted to select a build directory if you haven't selected one already. We recommend you choose a location outside of the project folder. Specify the location and click Select Folder.\n \t If your environment is set up correctly, the project should start building. Once finished, it will automatically load on your CAT-DEV, and a command prompt window will open up and display the output log. If it didn't load, or your build failed with other errors, please see the section on common Unity Editor errors and solutions for additional troubleshooting.\n Note\n If any application (other than System Config Tool) is running on your devkit, your game will fail to load. To cancel a running application, open cafex_env.bat and enter the command \"cafex stop\" (with no quotes).\n Using run.cmd\n First you must build your game. If you have already done this (for example, when using Build and Run previously), you can skip the steps to build your game.\n Build your game\n \t Open your project in Unity. If this is your first time building on this PC, we recommend first testing with a new project (see Verifying Your Environment is Setup Right).\n \t From the menu bar, select File > Build Settings.\n \t Under Platform, if Wii U is not already selected, select Wii U and then click Switch Platform.\n \t Set the Build Debug Level to Development. If you are using networking features in your game, or if you are using the Unity profiler and/or script debugging, set the Build Debug Level to Development[With Network]. If not, use Development[No Network].\n \t Set the Build Output to Unpackaged.\n \t Set the Boot Mode to PCFS.\n \t Click Build.\n \t You will be prompted to select a build directory if you haven't selected one already. We recommend you choose a location outside of the project folder. Specify the location and click Select Folder.\n \t If your environment is set up correctly, the project should start building. Once finished, it will open a file manager window for your build folder. If your build failed, please see the section on common Unity Editor errors and solutions for additional troubleshooting.\n Running your game\n Once your game is built, go into your build folder. There will be a file called run.cmd. If you double-click this file, it will run on your devkit, but the output log information will be lost if your game crashes. Instead, we recommend the following steps.\n \tTurn on your CAT-DEV (using the switch on the side of the devkit). You don't need to start it up with the \"cafex on\" command since it will start up automatically when run.cmd executes.\n \tOpen an MS-DOS terminal window.\n \tDrag and drop run.cmd on the terminal window.\n \tPress enter.\n Only the most recent lines from the output log will be displayed in the terminal. If you want to save the entire log file, you must export it to a text file. You can do so by typing ' > ' after run.cmd followed by the name and location of the text log you'd like to create. For example, the full command on step 3 above would look like this:\n D:\\unity_build_folder\\run.cmd > c:\\outputLog0001.txt\n Note\n If any application (other than System Config Tool) is running on your devkit, your game will fail to load. To cancel a running application, open cafex_env.bat and enter the command \"cafex stop\" (with no quotes).\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228414.html","Installing From SD Card",
"Installing From SD Card\nInstalling From SD Card\nTo launch a game from your devkit, you must first make a download image and install it to your devkit via SD card. The quickest method for building a download image is building it directly from the Unity Editor as described in this guide. Download images built in this way are fine for testing, but you cannot use them for master submission. If you need to create a download image for master submission, see the Mastering section.\nMaking the Download Image from Unity\n \t From the File menu, select Build Settings.\n \t Under Platform, if Wii U is not already selected, select Wii U and then click Switch Platform.\n \t Set the Build Debug Level to Development. If you are using networking features in your game, or if you are using the Unity profiler and/or script debugging, set the Build Debug Level to Development[With Network]. If not, use Development[No Network].\n \t Set the Build Output to Download Image. The Boot Mode does not matter.\n Note\n Although it is fine for testing, do not use the Download Image build option when preparing a master for submission.\n \t Click Build.\n \t You will be prompted to select a build directory. We recommend you choose a location outside of the project folder. Specify the location and click Select Folder.\n \t If your environment is set up correctly, the project should start building. Once finished, it will open a file manager window for your build folder. If your build failed, please see the section on common Unity Editor errors and solutions for additional troubleshooting.\n \tIn your build folder, there will be a folder called copyToSDCard. Copy that to an SD card.\nInstalling on Your Devkit\n To install a title, follow these steps:\n \tCopy the download image to an SD Card.\n \tTurn on your devkit, and open the System Config Tool. For a CAT-DEV, you will need to run cafex_env.bat and enter the command 'cafex on'. If you boot to the Wii U Menu , the System Config Tool will be one of the icons on the Wii U menu screen.\n \tInsert the SD Card into the devkit.\n \tSelect Data Manager.\n \tSelect Title Manager and then Install.\n \tSelect SD Card and then /vol/app_sd/.\n \tSelect the desired directory and press the A Button.\n \tInstall the title using the R button on the GamePad (or the 2 Button on a Wii Remote).\nRunning an Installed Title\n Titles can be run from the System Config Tool or the Wii U Menu, if it is installed.\nSystem Config Tool\n \tFrom the Root Menu of the System Config Tool, select Title Launcher.\n \tPress the A Button to select the desired title. Titles are displayed by their Title ID and the Short Name set in Title Information.\n \tPress the A Button again to run the project.\nWii U Menu\n \tIf your system is not set to boot to the Wii U Menu, launch Wii U Menu from System Config Tool.\tSelect Title Launcher\n\tSelect Wii U Menu\n\tPress the A button to launch it.\n \tSelect a user account and proceed to the main menu screen.\n \tOn the GamePad, select the icon for the title to be launched.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228421.html","Serial Logging on CAT-R",
"Serial Logging on CAT-R\nSerial Logging on a CAT-R\nIf you are developing using the CAT-R devkit, it is possible to get realtime logging output to your PC using a serial adapter. To do this, you will need a USB to serial adapter with a specific chip set. For details and the guide on how to use this, see Serial Logging on the Wii U in the Online Documents collection, or in your Cafe SDK manual under CAFE SDK Basics > CAT-R Quickstart Guide > Use your CAT-R > Serial Logging.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159228426.html","Debugging and Optimization",
"Debugging and Optimization\nDebugging and Optimization\nThis section will help you troubleshoot errors and optimize your game.\nTopics in This Section\n \t Unity Editor Error Troubleshooting\n \t Troubleshooting GHS MULTI\n \t Unity External Tools\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_159247957.html","3. Setting up Unity",
"3. Setting up Unity\n3. Setting up Unity\nThis procedure assumes you have already downloaded and installed Unity for Wii U and the Wii U development environment using Nintendo Dev Interface. If you have not yet done so, please follow the procedures described in Installing Nintendo Dev Interface and Installing Required Software Packages.\nIf this is the first installation of Unity on this PC, follow the Setting up Unity for the First Time instructions. If you already have Unity installed on this PC, you must update your license to get the Wii U build option. In this case, see the instructions.\n Info\n Unity for N3DS and Unity for Wii U require different serial keys. If you want to use both versions of Unity on the same host PC, you must switch the serial key every time you change between versions.\nSetting up Unity for the First Time\n \tRun Unity from the Start menu or from the shortcut on your desktop.\n \t Unity will be prompted for your Unity account information. You can create a new account or enter your existing credentials if you have them.\n \tNext, Unity will give you the option of Professional Edition or Personal Edition. You will now need the serial key that was provided in the Unity release notes in Nintendo Dev Interface. Select the Professional Edition, enter the serial key, and click Next.\n \t Unity is now installed and ready for use with your development kit.\nSwitching to the Unity for Wii U License\n \tRun Unity from the Start menu or from the shortcut on your desktop.\n \t Create a new project.\n \t Select Help > Manage License.\n \t Click the Return License option, and then Confirm.\n \t Quit Unity and run it again.\n \t Next, Unity will give you the option of Professional Edition or Personal Edition. You will now need the serial key that was provided in the Unity release notes in Nintendo Dev Interface. Select the Professional Edition, enter the serial key, and click Next.\n \t Unity is now set up with the correct license and ready for use with your development kit.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161286581.html","5. Setting up Your Devkit",
"5. Setting up Your Devkit\n5. Setting up Your Devkit\nFor setting up and using the CAT-DEV, see these sections first:\n \t Setting up the CAT-DEV Development Kit\n \t Connecting Your Devkit to the Internet\n \t Running Your Game on a Wii U Devkit\nFor setting up and using the CAT-R, see these sections first:\n \t Setting up the CAT-R Development Kit\n \t Connecting Your Devkit to the Internet\n \t Running Your Game on a Wii U Devkit\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161286634.html","Connecting to the Internet",
"Connecting to the Internet\nConnecting Your Devkit to the Internet\n Note\n The LAN connection on the front of your CAT-DEV is not used for the internet. In order to connect to the internet, you need a secondary network connection. This can either be via a USB LAN adapter, or via a wireless network router. Both the CAT-DEV and CAT-R devkits come equipped with wireless networking.\nThere are two ways to connect to internet. Both methods can be done on either devkit, but use of the Wii U Menu requires that you have already installed the Wii U Menu Changer.\nSetting up the Connection Using the Wii U Menu\nIf you have the Wii U Menu Changer installed, this is the easiest method. This is exactly the same as a retail Wii U. Launch the Wii U menu, go to System Settings > Internet and follow the instructions. You can verify your connection by starting the Internet Browser and trying to view a webpage.\nSetting up the Connection Using the System Config Tool\n \tIf you are not planning to use wireless networking, plug in a USB LAN adapter, and connect that to a router with access to the internet.\n \tTurn on your devkit. If you are using a CAT-DEV, you will also need to run the command \"cafex on\" in cafex_env.bat.\n \tIn System Config Tool, go to Network Setting.\n \tSelect Profile 1. (Any profile is fine to use, but we will use Profile 1 for this guide.)\n \tSet Status to Valid. Note that you must press the A Button to save your changes before pressing the B Button to move on.\n \t Select Edit Config.\n \t Set the Connection Mode. If you are setting it to Wireless, go to step 9. If you are setting it to Wired, go to step 10.\n \t For Wireless:\n \tSelect Access Point (AP) Setting.\n \t Select Scan.\n \t Select Update to get a list of available wireless networks.\n \t Scroll down and select the desired network.\n \t Select Privacy Key, then use the touchpad or a keyboard to enter the password for the network. The password will be displayed in plain text. To enter the text using a keyboard, either plug a USB keyboard into your devkit, or if you are using a CAT-DEV, you can enter commands using your PC keyboard if your Cafex_env console window has focus.\n \t Once you are finished entering the configuration information for the Access Point, back out of the Edit Config screen\n \t Select Connection Test to see if everything is working correctly.\n \t If everything is working correctly, back out of the Profile 1 screen\n \t Scroll up to Select Default Profile and make sure Profile 1 is selected.\nIf you are using network features that require an NNID such as Miiverse or an independent server in your game, you will also need to set up an NNID on your devkit.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161286636.html","Commands for CAT-DEV",
"Commands for CAT-DEV\nBasic Commands for the CAT-DEV\nAll commands here are entered using cafex_env.bat. You can find this file in your CAFE SDK directory.\nTurning on the CAT-DEV\n Note\n Do not press the power button on the front of the devkit to turn it on or you will get an error. This is for running your kit in headless mode (running it when not connected to a PC). To set your kit to use headless mode, see your SDK documentation.\n \tPress the switch on the side of the devkit labelled OFF ON.\n \tWait a few seconds for the devkit to power on. The STAT light on the front of the devkit will turn blue when it is ready.\n \tOpen cafex_env.bat. If you get an error that your devkit could not be found, either you waited too little in step 2, or something is not right with your connection. If you have a problem, wait 10 seconds and try reopening cafex_env.bat. If that doesn't work, verify your network cable is connected and network firewalls are configured correctly.\n \tIn cafex_env.bat, type \"cafex on\" (without quotes).\nShutting down your CAT-DEV\nSimilar to starting the CAT-DEV up, turning the CAT-DEV off is also done via your PC. It is recommended that you exit applications/shut down the system as follows:\n \tIn your cafex_env.bat session, press CTRL-C to break the terminal connection.\n \tAt the prompt, type \"cafex stop\" (without quotes) and hit enter.\n \tThe system will quit the software and turn off (back to the idle state). To turn the system completely off, shut it off using the power switch on the right side.\n Controlling the CAT-DEV via the PC Keyboard\n You can also use your PC keyboard instead of a controller to navigate the System Config Tool menu. After using \"cafex on\", if the cafex_env.bat has focus (it is the active window), keyboard commands will go directly to the System Config Tool. This is convenient for typing in passwords, etc.\n List of commands\n \tCommand \tPurpose\n \tcafex run \tRun an rpx file on your devkit\n \tcafex update \tUpdate the devkit firmware. See here for more details.\n \tcafex on \tBoot up the devkit\n \tcafex stop \tShut down the devkit (does not turn it fully off)\n \tfindbridge -all \tList all CAT-DEV and CAT-R devkits that can be found on the network. See here for more details.\n \t setbridge -default <Device Name> <IP Address>\n \tSet the indicated devkit as the default device. See here for more details.\n \thostdisplayversion \tList the version of the Host Bridge software and firmware\n Info\n For more commands see the cafex guide in your Cafe SDK manual.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161286841.html","Setting up an NNID on your Devkit",
"Setting up an NNID on your Devkit\nSetting up an NNID on your Devkit\nYou will need to set up an NNID on your devkit if you are using any network features that use NNIDs, such as Miiverse and independent servers. If you are only accessing the internet you do not need to set up an NNID.\nThe documentation on how to set this up exists in your SDK manual in the Account Manager guide. This is located at <CAFE_ROOT>\\system\\docs\\man\\en_us\\nn\\public\\API\\html\\tool_actmgr.html. The documentation gives you the Cygwin command to run, but if you are using cafex_env.bat, enter the following line in the command prompt to run the Account Manager (actmgr.rpx) on your devkit.\n cafex run %CAFE_ROOT%/system/bin/ghs/cafe/app/actmgr/NDEBUG/actmgr.rpx\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161293421.html","6. Checking if you Need to Update",
"6. Checking if you Need to Update\n6. Checking if you Need to Update\nThe SDK on your devkit should match the SDK you are using for development. To see what SDK version(s) you are using, do the following:\n \tRun cafex_env.bat. The initial output will list what SDK versions you are using.\n \tIf your devkit is not already on and running System Config Tool, turn on your devkit, type \"cafex on\" and hit enter.\n \tIn System Config Tool go to Software Version Information.\n \tLook under Cafe OS SDK Version. If these SDK versions do not match, you will need to update your CAT-DEV.\nThat is it for setting up the CAT-DEV.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161300085.html","Setting up CAT-R",
"Setting up CAT-R\nSetting up the CAT-R Development Kit\n This guide provides basic steps for quickly setting up an environment for development with Nintendo Web Framework and a CAT-R development system.\nUnpack and Plug in the System\n To connect the CAT-R, follow the steps below.\n \tUsing the power cable, plug the system in to an electrical outlet.\n \tConnect the system to a monitor using the HDMI or other video cable.\n \tConnect the Sensor Bar cable to the port on back of the system and place the Sensor Bar underneath or above the monitor to be used for output.\n \tPlug in the Wii U GamePad with its power adapter.\n \tConnect the Wii U GamePad to the DRC1 port using a wired connection.\n \tOn the top of the CAT-R and the protruding part of the Wii U GamePad, set the switch to wired.\n \tTo turn the CAT-R on, press the Power button on the front of the system.\n \tAfter the CAT-R starts up, the System Config Tool is displayed on the connected monitor.\n Info\n For information about how to operate the System Config Tool, see the SDK documentation.\nPair the Wii Remote Plus\n Included with the CAT-R is a Wii Remote Plus. To pair this controller, make sure the system is on, press the SYNC Button on the front of the CAT-R, and then press the SYNC Button on the back of the Wii Remote Plus. When the sync is complete, a Player LED on the front of the Wii Remote Plus will become lit.\nPair the Wii U GamePad\n In order to use the Wii U GamePad, it must be paired to the system if it is not already paired. When using the System Config Tool, follow this procedure:\n \tEnter the Wii U GamePad (DRC) Setting menu.\n \tSelect the Pair DRC option.\n \tPress the POWER Button on the Wii U GamePad.\n \tPress the SYNC Button on the back of the Wii U GamePad.\n \tEnter the symbols shown on the TV into the Wii U GamePad.\n \tThe Wii U GamePad will complete the sync process, and will then function with the paired system. When in the System Config Tool, the Wii U GamePad can control the cursor and be used for touch input with onscreen keyboards.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161306357.html","Updating Your Devkit",
"Updating Your Devkit\nThe steps for updating the CAT-R and CAT-DEV are slightly different, so they have been broken into their own respective sections.\nTopics in This Section\n \t Updating CAT-DEV\n \t 1. Preparation\n \t 2. Running System Updater\n \t 3. Updating GamePad Firmware\n \t 4. Updating Host Bridge\n \t Updating CAT-R\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161306361.html","Updating CAT-R",
"Updating CAT-R\nUpdating a CAT-R System\n Before starting development with Unity, the CAT-R and Wii U GamePad firmware must be updated to the correct version. The following guide explains the procedure for updating the CAT-R and Wii U GamePad firmware.\nUpdating the CAT-R Firmware\n Before updating the firmware on the system, check the current version of the firmware with the following steps:\n \tTurn on the CAT-R. The System Config Tool will start.\n \tSelect Software Version Information.\n \tIn this screen, check the Cafe OS SDK Version matches the Cafe SDK you are using. If these numbers match, skip this section and proceed to the Wii U GamePad firmware update procedure below. However if the version numbers do not match, the system firmware needs to be updated. This procedure will require the following:\tSD Card - This will be formatted so all existing data on the SD Card will be lost.\n\tDD for Windows 0.9.9.6 (DDWin) - Download this and extract the folder to your PC. (Also read the DDWin freeware license terms before using the tool.)\n\tThe CAT-R Firmware Update Image for the SDK you are using. This is included in the CAT-R Updater package available on the Downloads pages.\n \tInstall the Update Image on the SD Card.\n\tInsert a SD Card into the host PC.\n\tOpen the folder where you unzipped DD for Windows 0.9.9.6, right-click DDWin.exe, and then select Run as Administrator.\n\tUnder Target disk, select the drive letter for the SD Card.\n\tSelect the downloaded CAT-R Firmware Update Image under Target file.\n\tClick Restore and follow the prompts.\n\tSafely eject the SD Card from the host PC.\n \tUpdate the CAT-R firmware.\tPower off the CAT-R by holding down the Power Button for 4 seconds.\n\tInsert the SD Card into the system.\n\tPress the Eject and Power Buttons at the same time, and then release both.\nWarning\nDO NOT POWER OFF THE CAT-R until the LED sequence shows success or failure.\nThe following table describes the states of the LED indicator.\n \tDescription \tLED Sequence\n \tInstallation in progress \tBlue → Red → Orange\n \tInstallation successful \tBlue → Orange\n \tError code - The error code is represented by the number of Orange → Red or Blue → Red pulses. \tOrange → Red → Blue → Red → Red → Red\n Updating the Wii U GamePad Firmware\n The Wii U GamePad firmware must also be updated separately from the CAT-R. To update the Wii U GamePad, run the System Config Tool and follow the below procedure:\n \tEnter the Wii U GamePad (DRC) Setting menu.\n \tLook at the line starting with Firmware Version. If the numbers to the right of DRC and DRH are the same, the Wii U GamePad firmware is up to date.\n \tIf this is not the case, the Wii U GamePad firmware needs to be updated. Select Update DRC firmware to update the firmware.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161306383.html","1. Preparation",
"1. Preparation\n1. Preparation\n \tThe CAT-DEV must be set to Development Mode before performing the update.\tIn the System Config Tool (on your CAT-DEV), go to Boot Configuration.\n\tSet System Mode to Development Mode (if it is not already set to Development Mode).\n \tThe CAT-DEV and PC must be in PCFS mode. This is the default setting. You can verify it by opening cafex_env.bat and reading the output. CAFE_BOOT_MODE should be PCFS.\nIf it is not, see the setbootmode.bat section in your Cafe SDK documentation on how to change it back.\n \t Using the package description for the Unity version you will use, see what versions of the Cafe SDK and Green Hills MULTI software you will need. You can find the package description on the Downloads page.\n \t Install the Cafe SDK and/or Green Hills MULTI software on your PC. If you are using NDI to download and install these packages, the installation can be handled for you. If you are installing manually, unzip the SDK into a clean directory, and set CAFE_ROOT to point to this new directory. Also be sure GHS_ROOT points to the latest installation of GHS MULTI.\n Warning\n Do not install the SDK on top of a previous release unless directly specified to. SDK releases are intended as standalone releases unless specified.\n \t Check which version of the Host Bridge Software your CAT-DEV is using.\n \t In cafex_env.bat, enter the command \"hostdisplayversion\" (without quotes).\n \t The 'Bridge PC Tools' line represents the version of the software installed on the PC, while the 'Bridge Firmware' line represents the firmware version installed on the CAT-DEV itself.\n \t You can find the latest version of the Host Bridge Software on the Downloads page.If you are not using the latest version, you will need to install that as well. Instruction are on 4. Updating the Host Bridge.\n Info\n Typically, using the latest release of the Host Bridge Software is supported even on older SDKs. If you need to downgrade your SDK, it is probably not necessary to downgrade the Host Bridge Software as well.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161306412.html","Unity Editor Error Troubleshooting",
"Unity Editor Error Troubleshooting\nCommon Unity Editor Error Messages and Troubleshooting\nIf you get a build error with your regular game project, we recommend troubleshooting using a new, empty project since it is easier to identify the cause. If you can get the empty project to build without problems, it means your development environment is set up correctly.\nOne problem in your development environment can produce different errors depending on the PC and the project you are working on. The errors given below are sample errors. The actual output on your system might be slightly different.\n \tType of Error \tSample Error Message \tPossible Cause\n \tNamespace error \terror CS0234: The type or namespace name `WiiU' does not exist in the namespace `UnityEngine'. Are you missing an assembly reference? \tYour platform is not set to Wii U. See here for how to set this.\n \tNever progresses beyond \"Attempting to launch\" \t You get the following message, but even after waiting a few minutes, your build is never launched on your devkit:\n Attempting to launch in C:/<BUILD_DIRECTORY>\n \t Your CAT-DEV is off or not connected, or you are using Build And Run, but only have a CAT-R. CAT-R cannot use Build And Run. Just use Build, and install your game to your devkit via SD card.\n If you are using a CAT-DEV, try using cafex_env.bat to see if you can find your devkit with that. If you cannot, try setting up your CAT-DEV network settings again. You may first want to reinitialize the network settings.\n \tGHS_ROOT not found \tException: Environment variable GHS_ROOT not found. Add it to the program environment or assign it in Editor preferences. \tYou must set the GHS_ROOT environment variable. See the first section in Troubleshooting GHS MULTI for how to do this.\n \tCompilation error \t Exception: Failed to compile C into .o (C:/<BUILD_DIRECTORY>\\_Intermediate\\WiiUMain.cpp) UnityEditor.WiiU.PostProcessCafePlayer+CafeUtils.CompileCC...\n \t Your CAFE_ROOT system variable is not set to point to your Cafe SDK installation. If you used the NDI client to set up your environment, it installed a script called SetupEnvironment.wsf to automatically set up the system environment variables. Run that if you have not already, then restart your machine.\n It also could be due to your variables not being set in the Unity Editor. See here for more details.\n If that does not work, try troubleshooting GHS MULTI.\n Also, be sure there are no spaces in your Cafe SDK or GHS MULTI install path, and no spaces in your build directory.\n \tAny error with \"ghs\" in the text. \tWin32Exception: ApplicationName='c:\\ghs\\multi5326\\cxppc.exe', CommandLine='-G -Ogeneral -cpu=espresso -c99 -kanji=shiftjis -sda=none -X332 --no_implicit_include -dbg_source_root \". \t There is a problem involving GHS MULTI. See here for troubleshooting GHS MULTI.\n Also, be sure there are no spaces in your Cafe SDK or GHS MULTI install path, and no spaces in your build directory.\n \tCross compilation errors \t UnityException: Cross compilation failed.\n at UnityEditor.WiiU.PostProcessCafePlayer.CompileAOT (BuildTarget target, BuildOptions options, WiiUBuildDebugLevel variant, System.String codeDir, Boolean allowDebugging, System.String stagingAreaDataManaged, System.String targetDir)\n \t There is most likely a problem involving GHS MULTI. See here for troubleshooting GHS MULTI.\n It also could be due to your variables not being set in the Unity Editor. See here for more details.\n Be sure there are no spaces in your Cafe SDK or GHS MULTI install path, and no spaces in your build directory.\n \tAssembly conversion error \t UnityException: Assembly conversion failed.\n at UnityEditor.WiiU.PostProcessCafePlayer.CompileAOT (BuildTarget target, BuildOptions options, WiiUBuildDebugLevel variant, System.String codeDir, Boolean\n \t There is most likely a problem involving GHS MULTI. See here for troubleshooting GHS MULTI.\n It also could be due to your variables not being set in the Unity Editor. See here for more details.\n Be sure there are no spaces in your Cafe SDK or GHS MULTI install path, and no spaces in your build directory.\n \t\"Failed to Move\" errors \t IOException: Failed to Move File / Directory from 'Temp/StagingArea/Data' to C:/<BUILD_DIRECTORY>/content/Data'.\n Error building Player: IOException: Failed to Move File / Directory from 'Temp/StagingArea/Data' to 'C:/<BUILD_DIRECTORY>/content/Data'.\n \t The build directory is either in use, or is not accessible.\n \tIf you are still running a program on your devkit, close it by opening cafex_env.bat and typing \"cafex stop\".\n \tYour computer might have an active lock on one of the files. Restart your computer, or just make a new build directory.\n \tIf you are using a network or shared drive, try locating the build directory on another local drive.\n \tThere is no Wii U build option \t \t This could be one of two things:\n \tYour Unity license is not valid for the Wii U. See here for more details.\n \tYou did not install the Wii U support patch for Unity. This is handled automatically by NDI, so we recommend setting up your environment using NDI.\n \tAny other error \t \t Verify you are using the correct SDK version for your Unity for Wii U version. See the Middleware Version Table to find what SDKs correspond to your version of Unity.\n After doing that, try the above methods (especially restarting your PC), as they most likely will resolve the error.\n If none of the above methods have resolved your issue, something may have gone wrong when setting up your environment. Uninstalling the development environment (including Unity) and reinstalling it (with all virus/malware protection software removed or disabled) might fix the problem. Also try looking for a solution on the forums.\nTopics in This Section\n \t Troubleshooting GHS MULTI\n \t Unity External Tools\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161306505.html","Troubleshooting GHS MULTI",
"Troubleshooting GHS MULTI\nTroubleshooting GHS MULTI Issues\nUnity uses GHS Multi to compile the code that will be run on development hardware.\nVerify the installation and system environment variable\n \tGo to the GHS installation folder, and verify it exists. If you have not yet installed GHS, get the package from the NDP Downloads page, or use the NDI client.\n \tIf you have verified it is installed, open a MS-DOS command prompt window and type in the following:\necho %GHS_ROOT%\nYour output should point to the GHS installation, as it does with the following:\n \tIf it does not, be sure to set the system environment variable GHS_ROOT to point to the installation. In the command prompt, type in the following:\nsetx GHS_ROOT <GHS MULTI install directory>\nIf GHS MULTI was installed via the standard settings, the command would look like this:\nsetx GHS_ROOT c:\\ghs\\multi\n \tPress enter. You should get a response stating the variable was saved.\n \tIf you have set the GHS_ROOT variable, you must restart your computer for this change to take effect.\nVerify the GHS License\nIf your environment worked before on this PC and it suddenly stops working, the issue is often the GHS license being out of date. Checking your license is easy.\n \tGo to your GHS directory.\n \tRun mstart.exe.\n \tIf an error window appears, you need an updated license.\nYou can get a new license on the NDP Downloads page. For installation, follow the instructions in the readme included in the package.\nIf you got no error window, then your license file is up to date.\nTroubleshooting Communication with GHS\nIn order to compile the code, GHS needs to communicate with Unity. Virus and malware protection software can prevent this. On top of that, when you installed the virus/malware protection, it may have installed additional addons that you do not know about. If the addon is interfering with Unity/GHS communication, changing settings or even uninstalling the virus/malware protection software may do nothing. You will have to check your system for any process that may have been installed by the protection software.\n \tDisable the protection software. If that works, you can try adjusting the settings until you find a good compromise that allows for both the protection software and your development environment to operate.\n \t If that doesn't work, try uninstalling the protection software, restarting your computer, and trying again.\n \t If that doesn't work, press ctrl + alt + del.\n \t Click on Start Task Manager.\n \t Click on Processes.\n \t Verify that no more elements of your virus/malware protection software is running. If there are some, stop those processes, and try building your game in Unity again.\n \t If that doesn't work, look up what each process is (using the internet). Stop any process related to virus/malware protection.\n \t If that doesn't work, try uninstalling your development environment and starting again.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_161312589.html","Unity External Tools",
"Unity External Tools\nTroubleshooting Unity External Tools Settings\nBy default, Unity points itself to your GHS and Cafe SDK location. If you set up your environment with non-standard paths or changed some settings, Unity might no longer point to the right directories. Problems here are very rare, but it is also very easy to check.\n \tIn the Unity menu, go to Edit > Preferences > External Tools.\n \tMake sure Wii U SDK location and MULTI location are set to the location of the Cafe SDK and GHS Multi. By default, this would be your CAFE_ROOT and GHS_ROOT variables.\n \tIf they are pointing to the CAFE_ROOT and GHS_ROOT variables, you can verify the path easily. Open an MS-DOS command prompt and enter the following:\necho %CAFE_ROOT%\necho %GHS_ROOT%\n \tYour output should look something like this:\nVerify that these directories are indeed where you have installed to. If you have set environment variables during this Windows session, try restarting your computer so that the changes will take effect\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_194636021.html","Audio on the Wii U GamePad",
"Audio on the Wii U GamePad\nPlaying audio on the GamePad is not completely straightforward. This tutorial will walk you through the steps needed to get audio playing on the GamePad. A starting point for this tutorial can be downloaded from the Unity for Wii U Basics page.\nTopics in This Section\n \t Importing the Audio Assets\n \t Setting up the AudioSouce\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_194636037.html","Importing the Audio Assets",
"Importing the Audio Assets\n Info\n A starting point for this project can be found be downloaded from the Unity for Wii U Basics page.\nThe audio that you want to play will need to reside under the Assets folder of your project. For the purpose of this tutorial, any WAV file will work.\nThe following procedure describes the required steps for Importing an audio asset into a Unity project.\n \tCopy the file into your projects asset folder, and it will show up in Unity. For this example, I added a WAV file called BackgroundMusic.wav.\n2. For playing audio on the GamePad, make sure Compression Format is set to GCADPCM. This is the only format that is supported by the GamePad.\n3. Next, you will need to apply these setting. This can be done by clicking Apply or at any time by right-clicking the asset and selecting Reimport from the context menu.\n4. Unity will now process the asset with the settings from the Inspector and your audio should be ready to go.\nCONFIDENTIAL\n",0,"en-US"]
,["Pages/Page_194636396.html","Setting up the AudioSouce",
"Setting up the AudioSouce\nCreating an Audio Source\nAn audio source is a Unity component that can be attached to any Unity object. For the purpose of this guide we will just be using an empty asset.\n \tCreate an empty object in the scene.\n \tSelect the object and in the Inspector, click Add Component.\n \tSelect Audio > AudioSource.\n \tIn the component set, Audio Clip to the WAV asset you imported.\nHooking Up AudioSource in Code\nTo play back this audio source on the GamePad, we need to configure it in a script.\n \tAdd a new Script component to the game object. In this tutorial, we will name it AudioPlayer.\n \tEdit that script.\n \tIn order to get the AudioSource playing, the code requires the following.\tAccess to the AudioSource\n\tAudio source applied to an AudioSourceOutput\n\tAudioSource being told to play\n\t1\n2\n3\n4\n5\n6\n7\n8\n9\n10\n11\n12\n13\n14\n15\n16\n17\n18\tusing UnityEngine;\nusing System.Collections;\nusing WiiU = UnityEngine.WiiU;\npublic class AudioPlayer : MonoBehaviour {\n private AudioSource source;\n // Use this for initialization\n void Start () {\n // Get the AudioSource from the object and assign it to the GamePad.\n source = GetComponent<AudioSource>();\n WiiU.AudioSourceOutput.Assign(source, WiiU.AudioOutput.GamePad);\n source.loop = true;\n source.Play();\n }\n}\n \tBuild and run the project and your audio will play on the GamePad.\nCONFIDENTIAL\n",0,"en-US"]
];
for (var x = 0; x < additionalData.length; x++) Search.indexData.push(additionalData[x]);
Search.additionalData = additionalData;
})();
